﻿using Newtonsoft.Json;
using PoE_MxFilterGen.generator;
using PoE_MxFilterGen.json;
using System;
using System.Collections.Generic;
using System.IO;

namespace PoE_MxFilterGen
{
    internal class main
    {
        private static DateTime dt = DateTime.Now;
        public static string version = "9.0.0";
        public static string fDate = string.Format("{0}-{1}-{2}", (object)main.dt.Day, (object)main.dt.Month, (object)main.dt.Year);
        public static string api = "";
        public static string giturl = "https://git.mxnet.xyz/mikx";
        public static string section = "";
        public static string league = "";
        public static string path = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
        public static int fprog = 0;
        public static int ftotal = 0;
        public static int sprog = 0;
        public static int stotal = 0;
        public static bool deb = false;
        public static string[] filters = new string[4]
        {
      "Normal",
      "Strict",
      "Strict_NSNLC",
      "Strict_Caster"
        };

        private static void Main(string[] args)
        {
            if (!File.Exists("config/mxfiltergen_settings.json"))
            {
                msg.CMW("ERROR: settings.json not found! Downloading a template...", true, 3);
                web.DownloadFile("https://poe.mikx.xyz/mxfilter/data/settings_template.json", "config/mxfiltergen_settings.json");
            }
            msg.Splash();
            main.CleanDirData();
            main.league = JsonConvert.DeserializeObject<main.REMVAR>(File.ReadAllText("config/mxfiltergen_var.json")).league;
            main.api = "https://poe.ninja/api/data/";
            msg.CMW("League: " + main.league, true, 1);
            msg.CMW(string.Format("Min. Unique Value - {0}c", (object)settings.GetUniqueValue()), true, 1);
            msg.CMW(string.Format("Min. Fossil Value - {0}c", (object)settings.GetFossilValue()), true, 1);
            msg.CMW(string.Format("Min. Card Value   - {0}c", (object)settings.GetCardValue()), true, 1);
            msg.CMW("Checking for required dirs...", true, 1);
            if (!Directory.Exists("data"))
                Directory.CreateDirectory("data");
            if (!Directory.Exists("gen"))
                Directory.CreateDirectory("gen");
            if (!Directory.Exists("structure"))
                Directory.CreateDirectory("structure");
            msg.CMW("Cleaning the base dirs...", true, 1);
            main.CleanDirData();
            msg.CMW("Cleaning the last filter from path...", true, 1);
            foreach (string filter in main.filters)
                File.Delete("out/MxFilter_" + filter + ".filter");
            msg.CMW("Downloading the latest API data from poe.ninja...", true, 1);
            web.SaveString(main.api + "itemoverview?league=" + main.league + "&type=UniqueArmour&language=en", "data/ninja.armour.json");
            web.SaveString(main.api + "itemoverview?league=" + main.league + "&type=UniqueWeapon&language=en", "data/ninja.weapon.json");
            web.SaveString(main.api + "itemoverview?league=" + main.league + "&type=UniqueAccessory&language=en", "data/ninja.accessory.json");
            web.SaveString(main.api + "itemoverview?league=" + main.league + "&type=DivinationCard&language=en", "data/ninja.card.json");
            web.SaveString(main.api + "currencyoverview?league=" + main.league + "&type=Currency&language=en", "data/ninja.currency.json");
            web.SaveString(main.api + "itemoverview?league=" + main.league + "&type=Fossil&language=en", "data/ninja.fossil.json");
            foreach (string filter in main.filters)
            {
                string str = "MxFilter";
                main.RootStructure rootStructure = JsonConvert.DeserializeObject<main.RootStructure>(File.ReadAllText("structure/" + filter + ".json"));
                msg.CMW(string.Format("Generating the {0} filter using {1} source(s)...", (object)filter, (object)rootStructure.structures.Count), true, 1);
                main.ftotal = rootStructure.structures.Count;
                foreach (main.STRUCTURE structure in rootStructure.structures)
                {
                    if (structure.gen)
                    {
                        ++main.fprog;
                        msg.drawProgress(main.fprog, main.ftotal);
                        settings.WriteSection(structure.section);
                        string section = structure.section;
                        int fossilValue = settings.GetFossilValue();
                        int cardValue = settings.GetCardValue();
                        int uniqueValue = settings.GetUniqueValue();
                        switch (structure.section)
                        {
                            case "DIVINATION CARD (GEN)":
                                card.Gen(section, cardValue);
                                break;
                            case "EXPENSIVE UNIQUE (GEN) (Accessories)":
                                accessory.Gen(section, uniqueValue);
                                break;
                            case "EXPENSIVE UNIQUE (GEN) (Armours)":
                                armour.Gen(section, uniqueValue);
                                break;
                            case "EXPENSIVE UNIQUE (GEN) (Weapons)":
                                weapon.Gen(section, uniqueValue);
                                break;
                            case "FOSSIL (GEN)":
                                fossil.Gen(section, fossilValue);
                                break;
                            case "Tiers (DATA)":
                                tier.Gen(section);
                                break;
                            case "Tiers - Caster (DATA)":
                                tier_caster.Gen(section);
                                break;
                        }
                    }
                    else
                    {
                        ++main.fprog;
                        msg.drawProgress(main.fprog, main.ftotal);
                    }
                }
                msg.CMW("Creating the final filter...", true, 1);
                foreach (main.STRUCTURE structure in rootStructure.structures)
                {
                    if (structure.gen)
                    {
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", File.ReadAllText(string.Format("gen/" + structure.section + ".filter")));
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", Environment.NewLine ?? "");
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", Environment.NewLine ?? "");
                    }
                    else
                    {
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", string.Format("# Section: {0}", (object)structure.section) + Environment.NewLine);
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", Environment.NewLine ?? "");
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", File.ReadAllText(string.Format("structure/" + filter + "/" + structure.section + ".filter")));
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", Environment.NewLine ?? "");
                        File.AppendAllText("out/" + str + "_" + filter + ".filter", Environment.NewLine ?? "");
                    }
                }
                main.ftotal = 0;
                main.fprog = 0;
                main.CleanDir();
            }
        }

        public static void CleanDirData()
        {
            DirectoryInfo directoryInfo1 = new DirectoryInfo("data");
            DirectoryInfo directoryInfo2 = new DirectoryInfo("gen");
            foreach (FileSystemInfo file in directoryInfo1.GetFiles())
                file.Delete();
            foreach (FileSystemInfo file in directoryInfo2.GetFiles())
                file.Delete();
        }

        public static void CleanDir()
        {
            foreach (FileSystemInfo file in new DirectoryInfo("gen").GetFiles())
                file.Delete();
        }

        private static void AutoUpdater_ApplicationExitEvent() => Environment.Exit(-1);

        public class REMVAR
        {
            public string league { get; set; }
        }

        public class REMSND
        {
            public List<string> sound { get; set; }
        }

        public class STRUCTURE
        {
            public string section { get; set; }

            public bool gen { get; set; }

            public bool @static { get; set; }

            public bool remote { get; set; }

            public string url { get; set; }
        }

        public class RootStructure
        {
            public List<main.STRUCTURE> structures { get; set; }
        }
    }
}